<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Loop Nodes</TITLE>
<link href="suif1_17.html" rel=Next>
<link href="suif1_15.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_15.html">previous</A>, <A HREF="suif1_17.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC16" HREF="suif1_toc.html#TOC16">Loop Nodes</A></H3>
<P>
<A NAME="IDX64"></A>
<A NAME="IDX65"></A>

</P>
<P>
<A NAME="IDX66"></A>
<A NAME="IDX67"></A>
<A NAME="IDX68"></A>
<A NAME="IDX69"></A>
<A NAME="IDX70"></A>
A <CODE>tree_loop</CODE> node represents a "do-while" loop.  It contains two
tree node lists: the <CODE>body</CODE> and the <CODE>test</CODE>.  The <CODE>body</CODE>
list comes first and holds the loop body.  The <CODE>test</CODE> list contains
code to evaluate the "while" expression and conditionally branch back
to the beginning of the body.

</P>
<P>
<A NAME="IDX71"></A>
<A NAME="IDX72"></A>
<A NAME="IDX73"></A>
<A NAME="IDX74"></A>
<A NAME="IDX75"></A>
<A NAME="IDX76"></A>
There are three labels associated with a <CODE>tree_loop</CODE> node:
<CODE>toplab</CODE>, <CODE>contlab</CODE>, and <CODE>brklab</CODE>.  The <CODE>toplab</CODE>
label marks the beginning of the loop <CODE>body</CODE>; the <CODE>test</CODE> list
typically contains a conditional branch back to <CODE>toplab</CODE>.  A
"continue" statement in the loop body requires a jump over the rest of
the body to the beginning of the test code.  The <CODE>contlab</CODE> label is
positioned at the beginning of the <CODE>test</CODE> list for this purpose.
Similarly, a "break" statement in the loop is translated to a jump to
the <CODE>brklab</CODE> label which is located immediately after the loop.
These <CODE>tree_loop</CODE> labels must be defined in the scope of the loop
node, but the label positions are implicit rather than being marked by
label instructions.  When the <CODE>tree_loop</CODE> is expanded to low-SUIF
form, the label instructions are inserted into the tree node lists.

</P>
<P>
Because the loop nodes are only intended for use with structured control
flow, certain restrictions on the contents of the <CODE>tree_loop</CODE>
lists are required.  The <CODE>test</CODE> part has exactly the same
restrictions as the <CODE>header</CODE> of a <CODE>tree_if</CODE> except that it
is the <CODE>toplab</CODE> label instead of the <CODE>jumpto</CODE> label to which
jumps and branches are allowed and expected.  See section <A HREF="suif1_15.html#SEC15">If Nodes</A>.  Note
in particular that use of the <CODE>brklab</CODE> and <CODE>contlab</CODE> labels
is not allowed in the <CODE>test</CODE> list.

</P>
<P>
The <CODE>body</CODE> list has restrictions analogous to the restriction on
<CODE>then_part</CODE> and <CODE>else_part</CODE> lists of a <CODE>tree_if</CODE>:
arbitrary nesting of other <CODE>tree_node</CODE>s is allowed, but control
flow into or out of the <CODE>body</CODE> is not allowed.  The <CODE>body</CODE>
list is allowed slightly more leeway, though: jumps or branches are
allowed from anywhere in the <CODE>body</CODE> to the <CODE>brklab</CODE> or the
<CODE>contlab</CODE> labels.  This is the only place where the <CODE>brklab</CODE>
or <CODE>contlab</CODE> labels can be used--they cannot be used outside the
<CODE>tree_loop</CODE> or in the <CODE>test</CODE> list.

</P>
<P>
Note that either or both of the <CODE>test</CODE> and <CODE>body</CODE> parts may
be empty lists, but if the <CODE>test</CODE> part is empty, the loop is
degenerate--it will always execute exactly once.

</P>
<P>
For example, the following C code could be translated into the SUIF code
shown in a simplified form below.  Note that because the <CODE>test</CODE>
code is at the <EM>bottom</EM> of the loop, the "while" loop must be
converted to a "do-while" loop guarded by an "if" node.  See section <A HREF="suif1_15.html#SEC15">If Nodes</A>.

</P>

<PRE>
while (k &#62; 0) {
    if (k = 1) break;
    k = k - 1;
    if (k &#60; 10) continue;
    k = k - 10;
}
</PRE>


<PRE>
IF (Jumpto=L:__L1)
IF HEADER
    bfalse e1, L:__L1
      e1: sl e2, k
        e2: ldc 0
IF THEN
    LOOP (Top=L:__L2 Cont=L:__L3 Brk=L:__L4)
    LOOP BODY
        btrue e1, L:__L4
          e1: seq k, e2
            e2: ldc 1
        sub k = k, e1
          e1: ldc 1
        btrue e1, L:__L3
          e1: sl k, e2
            e2: ldc 10
        sub k = k, e1
          e1: ldc 10
    LOOP TEST
        btrue e1, L:__L2
          e1: sl e2, k
            e2: ldc 0
    LOOP END 
IF ELSE 
IF END
</PRE>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_15.html">previous</A>, <A HREF="suif1_17.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
